# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['UserMetadataArgs', 'UserMetadata']

@pulumi.input_type
class UserMetadataArgs:
    def __init__(__self__, *,
                 key: pulumi.Input[str],
                 user_id: pulumi.Input[str],
                 value: pulumi.Input[str],
                 org_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a UserMetadata resource.
        :param pulumi.Input[str] key: The key of a metadata entry
        :param pulumi.Input[str] user_id: ID of the user
        :param pulumi.Input[str] value: The string representation of a metadata entry value. For binary data, use the base64encode function.
        :param pulumi.Input[str] org_id: ID of the organization
        """
        UserMetadataArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            user_id=user_id,
            value=value,
            org_id=org_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: pulumi.Input[str],
             user_id: pulumi.Input[str],
             value: pulumi.Input[str],
             org_id: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'userId' in kwargs:
            user_id = kwargs['userId']
        if 'orgId' in kwargs:
            org_id = kwargs['orgId']

        _setter("key", key)
        _setter("user_id", user_id)
        _setter("value", value)
        if org_id is not None:
            _setter("org_id", org_id)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        The key of a metadata entry
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> pulumi.Input[str]:
        """
        ID of the user
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "user_id", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        The string representation of a metadata entry value. For binary data, use the base64encode function.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the organization
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org_id", value)


@pulumi.input_type
class _UserMetadataState:
    def __init__(__self__, *,
                 key: Optional[pulumi.Input[str]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering UserMetadata resources.
        :param pulumi.Input[str] key: The key of a metadata entry
        :param pulumi.Input[str] org_id: ID of the organization
        :param pulumi.Input[str] user_id: ID of the user
        :param pulumi.Input[str] value: The string representation of a metadata entry value. For binary data, use the base64encode function.
        """
        _UserMetadataState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            org_id=org_id,
            user_id=user_id,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: Optional[pulumi.Input[str]] = None,
             org_id: Optional[pulumi.Input[str]] = None,
             user_id: Optional[pulumi.Input[str]] = None,
             value: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'orgId' in kwargs:
            org_id = kwargs['orgId']
        if 'userId' in kwargs:
            user_id = kwargs['userId']

        if key is not None:
            _setter("key", key)
        if org_id is not None:
            _setter("org_id", org_id)
        if user_id is not None:
            _setter("user_id", user_id)
        if value is not None:
            _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[str]]:
        """
        The key of a metadata entry
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the organization
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org_id", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the user
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[str]]:
        """
        The string representation of a metadata entry value. For binary data, use the base64encode function.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "value", value)


class UserMetadata(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_zitadel as zitadel

        default = zitadel.UserMetadata("default",
            org_id=default_zitadel_org["id"],
            user_id=default_zitadel_human_user["id"],
            key="a_key",
            value="a_value")
        ```

        ## Import

        bash The resource can be imported using the ID format `<user_id:key[:org_id]>`, e.g.

        ```sh
         $ pulumi import zitadel:index/userMetadata:UserMetadata imported '123456789012345678:a_key:123456789012345678'
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] key: The key of a metadata entry
        :param pulumi.Input[str] org_id: ID of the organization
        :param pulumi.Input[str] user_id: ID of the user
        :param pulumi.Input[str] value: The string representation of a metadata entry value. For binary data, use the base64encode function.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UserMetadataArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_zitadel as zitadel

        default = zitadel.UserMetadata("default",
            org_id=default_zitadel_org["id"],
            user_id=default_zitadel_human_user["id"],
            key="a_key",
            value="a_value")
        ```

        ## Import

        bash The resource can be imported using the ID format `<user_id:key[:org_id]>`, e.g.

        ```sh
         $ pulumi import zitadel:index/userMetadata:UserMetadata imported '123456789012345678:a_key:123456789012345678'
        ```

        :param str resource_name: The name of the resource.
        :param UserMetadataArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UserMetadataArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            UserMetadataArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UserMetadataArgs.__new__(UserMetadataArgs)

            if key is None and not opts.urn:
                raise TypeError("Missing required property 'key'")
            __props__.__dict__["key"] = key
            __props__.__dict__["org_id"] = org_id
            if user_id is None and not opts.urn:
                raise TypeError("Missing required property 'user_id'")
            __props__.__dict__["user_id"] = user_id
            if value is None and not opts.urn:
                raise TypeError("Missing required property 'value'")
            __props__.__dict__["value"] = value
        super(UserMetadata, __self__).__init__(
            'zitadel:index/userMetadata:UserMetadata',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            key: Optional[pulumi.Input[str]] = None,
            org_id: Optional[pulumi.Input[str]] = None,
            user_id: Optional[pulumi.Input[str]] = None,
            value: Optional[pulumi.Input[str]] = None) -> 'UserMetadata':
        """
        Get an existing UserMetadata resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] key: The key of a metadata entry
        :param pulumi.Input[str] org_id: ID of the organization
        :param pulumi.Input[str] user_id: ID of the user
        :param pulumi.Input[str] value: The string representation of a metadata entry value. For binary data, use the base64encode function.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UserMetadataState.__new__(_UserMetadataState)

        __props__.__dict__["key"] = key
        __props__.__dict__["org_id"] = org_id
        __props__.__dict__["user_id"] = user_id
        __props__.__dict__["value"] = value
        return UserMetadata(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Output[str]:
        """
        The key of a metadata entry
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> pulumi.Output[Optional[str]]:
        """
        ID of the organization
        """
        return pulumi.get(self, "org_id")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> pulumi.Output[str]:
        """
        ID of the user
        """
        return pulumi.get(self, "user_id")

    @property
    @pulumi.getter
    def value(self) -> pulumi.Output[str]:
        """
        The string representation of a metadata entry value. For binary data, use the base64encode function.
        """
        return pulumi.get(self, "value")

